﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Xml.Linq;
using System.Web.UI;

namespace MultiAspXml
{
    public class Global : System.Web.HttpApplication
    {

        protected void Application_Start(object sender, EventArgs e)
        {
            WriteLanguagekeyToXML();
        }

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
        /// <summary>

        /// 將判斷大陸版本或臺灣版本的標志寫入Web.xml add by bai_clong

        /// </summary>

        private void WriteLanguagekeyToXML()
        {

            //System.IO.FileStream fs = new System.IO.FileStream("/JS/JSXML/Web.xml",System.IO.FileMode.);

            System.Xml.XmlDocument xmldoc = new System.Xml.XmlDocument();

            //xmldoc.Load(HttpContext.Current.Server.MapPath(filePath + fileName));

            System.Web.UI.Page pg = new Page();

            string lastFilePath = System.AppDomain.CurrentDomain.BaseDirectory;

            lastFilePath += "JS\\JSXML\\Web.xml";

            if (!System.IO.File.Exists(lastFilePath))
            {
                CreateXml(lastFilePath);
            }

            xmldoc.Load(lastFilePath);
            System.Xml.XmlNode xmlnode = xmldoc.SelectSingleNode("/configuration/add[@key='Flag']");

            if (!xmlnode.Attributes["value"].Value.Equals(System.Configuration.ConfigurationManager.AppSettings["Flag"].ToString()))
            {
                xmlnode.Attributes["value"].Value = System.Configuration.ConfigurationManager.AppSettings["Flag"].ToString();
                xmldoc.Save(lastFilePath);
            }

        }


         /// <summary>6    
        /// 创建XML文件7   
        ///  </summary>  
        /// <param name="filePath">文件路径</param>9     
        /// 
      private void CreateXml(string filePath)
     {
        System.Xml.XmlDocument xmlDoc=new System.Xml.XmlDocument();
        System.Xml.XmlDeclaration declaration = xmlDoc.CreateXmlDeclaration("1.0", "utf-8","yes");//文档声明部分
        xmlDoc.AppendChild(declaration);

        System.Xml.XmlElement rootNode = xmlDoc.CreateElement("configuration");
        System.Xml.XmlElement xmlNode = xmlDoc.CreateElement("add");                        //根节点16 

        System.Xml.XmlAttribute xmlKey = xmlDoc.CreateAttribute("key");
        xmlKey.Value = " Flag";
        xmlNode.Attributes.Append(xmlKey);

        System.Xml.XmlAttribute xmlValue = xmlDoc.CreateAttribute("value");
        xmlValue.Value = "0";
        xmlNode.Attributes.Append(xmlValue);

        //string commentString = EventMessage.GetEventMessage(CommonString.XmlCommentString);// EventMessage是自定义类，从数据库中读取常量字符串，CommonString里面的常量字符串对应到数据库表中每一条记录的键
        //System.Xml.XmlComment comment = xmlDoc.CreateComment(commentString);
        //rootNode.AppendChild(comment);
        rootNode.AppendChild(xmlNode);
        xmlDoc.AppendChild(rootNode);

        xmlDoc.Save(filePath);
     }


    }
}