﻿

//獲得對應的漢字, js中调用此方法获取文字（message为Key）
var xmlDoc=null;
var b_load=null;
function getMessage(message)

{
    if(!b_load)
    {
        loadFile();
    }    
    String.prototype.trim=function()
    {
        return this.replace(/(^\s*)|(\s*$)/g,"");
    }
    return xmlDoc.selectSingleNode("langShow/formShow/add[@key='"+message.trim()+"']").getAttribute("value");

}
function getAlert(message)

{
    if(!b_load)
    {
        loadFile();
    }    
    String.prototype.trim=function()
    {
        return this.replace(/(^\s*)|(\s*$)/g,"");
    }
    return xmlDoc.selectSingleNode("langShow/alertmsg/add[@key='"+message.trim()+"']").getAttribute("value");

}


function getRootPath() {  
    var pathName = window.location.pathname.substring(1);  
    var webName = pathName == '' ? '' : pathName.substring(0, pathName.indexOf('/'));  
    return window.location.protocol + '//' + window.location.host + '/'+ webName ;  
}  
//加載xml文件

function loadFile()

{
    getLanguagekey();
    createDocumentObject();
    var spath;
    if(languagekey=="1")       //英文
    {
        spath=getRootPath()+"JS/JSXML/lang_en-us.xml";
      
    }
    else if(languagekey=="0")  //中文
    {
        spath=getRootPath()+"JS/JSXML/lang_zh-cn.xml";
    }
    if(!b_load)
    {
        b_load =xmlDoc.load(spath);
    } 
}

//firefox並不支援selectSingleNode和selectNodes方法;下面兩段是用XPath來解決firefox

//模擬selectSingleNode和selectNodes方法

//function createSelectSingleNodeAddSelectNodesMethod()
//{
//     
//    XMLDocument.prototype.selectSingleNode = Element.prototype.selectSingleNode = function (xpath){
//        var x = this .selectNodes(xpath)
//        if ( ! x || x.length < 1 ) return null 
//        return x[ 0 ];
//    }
//    XMLDocument.prototype.selectNodes = Element.prototype.selectNodes = function (xpath){
//        var xpe = new XPathEvaluator();
//        var nsResolver = xpe.createNSResolver( this.ownerDocument == null ?this.documentElement : this.ownerDocument.documentElement);
//        var result = xpe.evaluate(xpath, this , nsResolver, 0 , null );
//        var found = [];
//        var res;
//        while (res = result.iterateNext())
//        found.push(res);
//        return found;
//    }
//}

//創建文檔對象

function createDocumentObject()

{
    
    //ie
    if((xmlDoc==null) && window.ActiveXObject)

    {
        xmlDoc=new ActiveXObject("Microsoft.XMLDOM");//Msxml2.DOMDocument
    }
    //FF
    else if(document.implementation && document.implementation.createDocument)
    {
        xmlDoc=document.implementation.createDocument("", "", null);
        //createSelectSingleNodeAddSelectNodesMethod();
    }
    xmlDoc.async=false;

}


//獲得大陸或臺灣簡繁體標志信息

function getLanguagekey()

{
    var configDoc=null;
    //ie
    if((configDoc==null) && window.ActiveXObject)
    {
        configDoc=new ActiveXObject("Microsoft.XMLDOM");//Msxml2.DOMDocument
    }
    //FF
    else if(document.implementation && document.implementation.createDocument)
    {
        configDoc=document.implementation.createDocument("", "", null);
       // createSelectSingleNodeAddSelectNodesMethod();
    }
    configDoc.async=false;    
    var spath=getRootPath()+"JS/JSXML/Web.xml";
    var b_ok= configDoc.load(spath); 
    var languagekeyNode=configDoc.selectSingleNode("configuration/add[@key='Flag']");
    languagekey=languagekeyNode.getAttribute("value");

}

